import { jsx as T, jsxs as pe } from "react/jsx-runtime";
import ye, { useRef as f, useEffect as O, useCallback as me, useMemo as J, useState as E, useId as xe, useReducer as he, useLayoutEffect as I } from "react";
import c from "clsx";
/*!
  @versini/ui-textarea v3.0.12
  © 2025 gizmette.com
*/
try {
  window.__VERSINI_UI_TEXTAREA__ || (window.__VERSINI_UI_TEXTAREA__ = {
    version: "3.0.12",
    buildTime: "01/25/2025 11:56 AM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const K = "av-text-area", Ae = "av-text-area-wrapper", D = "av-text-area-helper-text", Te = "av-text-area__control--right", ge = "av-text-area__control--left";
function _e() {
  const e = f(!1);
  return O(() => (e.current = !0, () => {
    e.current = !1;
  }), []), me(() => e.current, []);
}
function be(e) {
  return J(() => e.every((n) => n == null) ? () => {
  } : (n) => {
    e.forEach((t) => {
      typeof t == "function" ? t(n) : t != null && (t.current = n);
    });
  }, e);
}
const ke = {
  x: 0,
  y: 0,
  width: 0,
  height: 0,
  top: 0,
  left: 0,
  bottom: 0,
  right: 0
};
function W(e) {
  const n = _e(), t = f(0), r = f(null), [a, s] = E(ke), o = J(() => typeof ResizeObserver > "u" ? null : new ResizeObserver((l) => {
    const u = l[0];
    u && (cancelAnimationFrame(t.current), t.current = requestAnimationFrame(() => {
      r.current && n() && s(u.contentRect);
    }));
  }), [n]);
  return O(() => (r.current && (o == null || o.observe(r.current, e)), () => {
    o == null || o.disconnect(), t.current && cancelAnimationFrame(t.current);
  }), [o, e]), [r, a];
}
function Re({
  value: e,
  defaultValue: n,
  finalValue: t,
  onChange: r = () => {
  },
  initialControlledDelay: a = 0
}) {
  const [s, o] = E(!1), [l, u] = E(
    n !== void 0 ? n : t
  ), p = (y) => {
    u(y), r == null || r(y);
  };
  return O(() => {
    (async () => e !== void 0 && !s && a > 0 && (await new Promise(
      (y) => setTimeout(y, a)
    ), o(!0)))();
  }, [e, a, s]), e !== void 0 ? !s && a > 0 ? ["", r, !0] : [e, r, !0] : [l, p, !1];
}
function Ee(e) {
  const n = xe();
  if (!e)
    return n;
  if (typeof e == "number" || typeof e == "string")
    return `${e}${n}`;
  if (typeof e == "object") {
    const { id: t, prefix: r = "" } = e;
    return typeof t == "number" || typeof t == "string" ? `${r}${t}` : `${r}${n}`;
  }
}
const Q = "SET_ANNOUNCEMENT", Y = "CLEAR_ANNOUNCEMENT", Ne = {
  alert: null,
  alertdialog: null,
  log: "polite",
  marquee: null,
  progressbar: null,
  status: "polite",
  timer: "assertive"
}, ve = (e, n) => {
  switch (n == null ? void 0 : n.type) {
    case Q:
      return {
        ...e,
        announcement: n.payload
      };
    case Y:
      return {
        ...e,
        announcement: null
      };
    default:
      return e;
  }
}, Ce = ({
  onAnnouncementClear: e,
  dispatch: n
}) => {
  n({
    type: Y
  }), typeof e == "function" && e();
}, q = ({
  children: e,
  clearAnnouncementDelay: n,
  clearAnnouncementTimeoutRef: t,
  onAnnouncementClear: r,
  dispatch: a
}) => {
  clearTimeout(t.current), e !== null && a({
    type: Q,
    payload: e
  }), n && (t.current = setTimeout(
    () => Ce({
      onAnnouncementClear: r,
      dispatch: a
    }),
    n
  ));
}, Ie = ({
  children: e,
  announcementTimeoutRef: n,
  announcementDelay: t,
  clearAnnouncementDelay: r,
  clearAnnouncementTimeoutRef: a,
  onAnnouncementClear: s,
  dispatch: o
}) => {
  clearTimeout(n.current), t ? n.current = setTimeout(q, t, {
    children: e,
    clearAnnouncementDelay: r,
    clearAnnouncementTimeoutRef: a,
    onAnnouncementClear: s,
    dispatch: o
  }) : q({
    children: e,
    clearAnnouncementDelay: r,
    clearAnnouncementTimeoutRef: a,
    onAnnouncementClear: s,
    dispatch: o
  });
};
function Le({
  children: e,
  className: n,
  politeness: t,
  role: r = null,
  announcementDelay: a,
  clearAnnouncementDelay: s,
  onAnnouncementClear: o,
  visible: l,
  ...u
}) {
  const p = f(null), y = f(null), [b, N] = he(ve, {
    announcement: null
  });
  let g = t;
  typeof g > "u" && (g = r ? Ne[r] : "assertive"), O(() => {
    Ie({
      announcementTimeoutRef: p,
      announcementDelay: a,
      children: e,
      clearAnnouncementDelay: s,
      clearAnnouncementTimeoutRef: y,
      onAnnouncementClear: o,
      dispatch: N
    });
  }, [
    e,
    a,
    s,
    o
  ]);
  const d = c(n, {
    "sr-only": !l
  });
  return /* @__PURE__ */ T(
    "div",
    {
      "aria-live": g,
      ...r && { role: r },
      className: d,
      ...u,
      children: b.announcement
    }
  );
}
/*!
  @versini/ui-liveregion v1.3.7
  © 2025 gizmette.com
*/
try {
  window.__VERSINI_UI_LIVEREGION__ || (window.__VERSINI_UI_LIVEREGION__ = {
    version: "1.3.7",
    buildTime: "01/25/2025 11:56 AM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const Se = () => "rounded-md text-base h-20 min-h-[80px] resize-none overflow-hidden px-4 py-7", Oe = ({ mode: e }) => c({
  "bg-surface-darker text-copy-lighter caret-copy-light": e === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": e === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": e === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": e === "alt-system"
}), we = ({
  focusMode: e
}) => c("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), $e = ({
  noBorder: e,
  error: n
}) => c("border-2", {
  "border-border-dark": !e && !n,
  "focus:border-border-dark": !e && n,
  "border-border-error-dark": !e && n,
  "border-transparent": e
}), He = ({
  disabled: e,
  raw: n,
  error: t,
  mode: r,
  leftElement: a,
  rightElement: s
}) => {
  if (n)
    return "";
  if (e)
    return c(
      "transform translate-y-0 scale-100 absolute px-2 cursor-not-allowed opacity-50 font-medium",
      {
        "translate-x-[12px]": s === !0 && !a || !s && !a
      }
    );
  if (!t)
    return c(
      "absolute px-2 cursor-text font-medium transform translate-y-0 scale-100",
      {
        "translate-x-[12px]": s === !0 && !a || !s && !a,
        "text-copy-medium": r === "dark",
        "text-copy-dark": r === "light",
        "text-copy-dark dark:text-copy-medium": r === "system",
        "text-copy-medium dark:text-copy-dark": r === "alt-system"
      }
    );
  if (t)
    return c(
      "absolute px-2 cursor-text font-medium transform translate-y-0 scale-100",
      {
        "translate-x-[12px]": s === !0 && !a || !s && !a,
        "text-copy-medium": r === "dark",
        "text-copy-error-dark": r === "light",
        "text-copy-error-dark dark:text-copy-error-light": r === "system",
        "text-copy-medium dark:text-copy-error-dark": r === "alt-system"
      }
    );
}, Me = ({
  error: e,
  raw: n,
  mode: t,
  disabled: r
}) => {
  if (n)
    return "";
  if (r)
    return c(
      D,
      "absolute px-2 cursor-not-allowed opacity-50 font-medium"
    );
  if (!e)
    return c(D, "absolute px-2 font-medium", {
      "text-copy-medium": t === "dark",
      "text-copy-dark": t === "light",
      "text-copy-dark dark:text-copy-medium": t === "system",
      "text-copy-medium dark:text-copy-dark": t === "alt-system"
    });
  if (e)
    return c(D, "absolute px-2 font-medium", {
      "text-copy-error-light": t === "dark",
      "text-copy-error-dark": t === "light",
      "text-copy-error-dark dark:text-copy-error-light": t === "system",
      "dark:text-copy-error-dark text-copy-error-light": t === "alt-system"
    });
}, De = ({
  className: e,
  textAreaClassName: n,
  raw: t,
  focusMode: r,
  disabled: a,
  noBorder: s,
  error: o,
  mode: l,
  leftElement: u,
  rightElement: p
}) => {
  const y = t ? e : c(
    "relative flex w-full flex-col justify-center",
    Ae,
    e
  ), b = t ? c(n) : c(
    K,
    n,
    Se(),
    Oe({ mode: l }),
    we({ focusMode: r }),
    $e({
      noBorder: s,
      error: o
    }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": a
    }
  ), N = t ? void 0 : "sr-only", g = He({
    disabled: a,
    raw: t,
    error: o,
    mode: l,
    rightElement: p,
    leftElement: u
  }), d = Me({
    error: o,
    raw: t,
    mode: l,
    disabled: a
  }), v = t ? void 0 : c(Te, "absolute"), h = t ? void 0 : c(ge, "absolute");
  return {
    wrapper: y,
    textArea: b,
    accessibleLabel: N,
    visibleLabel: g,
    helperText: d,
    rightElement: v,
    leftElement: h
  };
}, Fe = ({
  scrollHeight: e,
  currentHeight: n,
  currentLabelOffset: t = 0,
  currentHelperTextOffset: r = 0
}) => {
  let o, l;
  if (e > 0 && e !== n) {
    const u = e - n, p = Math.abs(u / 24);
    o = t + -1 * Math.sign(u) * (12 * p), l = r + Math.sign(u) * (12 * p);
  }
  return {
    labelOffset: o,
    helperTextOffset: l,
    scrollHeight: e
  };
}, Pe = ye.forwardRef(
  ({
    id: e,
    name: n,
    label: t,
    error: r = !1,
    raw: a = !1,
    className: s,
    textAreaClassName: o,
    mode: l = "system",
    focusMode: u = "system",
    value: p,
    defaultValue: y,
    disabled: b = !1,
    noBorder: N = !1,
    labelId: g,
    helperText: d = "",
    helperTextOnFocus: v = !1,
    rightElement: h,
    leftElement: k,
    onChange: F,
    onFocus: P,
    onBlur: U,
    ...Z
  }, ee) => {
    var B;
    const x = f(null), te = be([ee, x]), [ne, L] = W(), [re, R] = W(), w = f(80), V = f(-25), m = f(null), X = f(30), S = f(null), C = Ee({ id: e, prefix: `${K}-` }), [j, ae] = E(0), [G, se] = E(0), [oe, z] = E(
      !!(!v && d)
    ), ce = `${n} error, ${d}`, _ = De({
      className: s,
      textAreaClassName: o,
      error: r,
      raw: a,
      focusMode: u,
      disabled: b,
      noBorder: N,
      mode: l,
      rightElement: !!h,
      leftElement: !!k
    }), [A, le] = Re({
      value: p,
      initialControlledDelay: 20,
      defaultValue: y,
      onChange: (i) => {
        F && F({
          target: {
            value: i
          }
        });
      }
    }), ue = (i) => {
      le(i.target.value);
    }, ie = (i) => {
      v && d && z(!0), P && P(i);
    }, de = (i) => {
      v && d && !A && z(!1), U && U(i);
    };
    return I(() => {
      L && L.width && ae(L.width + 18 + 10);
    }, [L]), I(() => {
      R && R.width && se(R.width + 18 + 10);
    }, [R]), I(() => {
      a || x && x.current && A !== void 0 && (x.current.style.height = "inherit", x.current.style.height = x.current.scrollHeight + "px");
    }, [A, a]), I(() => {
      a || setTimeout(() => {
        var i;
        (i = m == null ? void 0 : m.current) == null || i.style.setProperty(
          "--av-text-area-wrapper-transition",
          A ? "none" : "all 0.2s ease-out"
        );
      }, 0);
    }, [A, a]), I(() => {
      var i, $;
      if (!a && x && x.current && A !== void 0) {
        const { labelOffset: H, helperTextOffset: M, scrollHeight: fe } = Fe({
          scrollHeight: x.current.scrollHeight,
          currentHeight: w.current,
          currentLabelOffset: V.current,
          currentHelperTextOffset: X.current
        });
        H && (V.current = H, (i = m == null ? void 0 : m.current) == null || i.style.setProperty(
          "--av-text-area-label",
          `${H}px`
        )), M && (X.current = M, ($ = S == null ? void 0 : S.current) == null || $.style.setProperty(
          "--av-text-area-helper-text",
          `${M}px`
        )), w.current = fe || w.current;
      }
    }, [A, a]), R.width > 0 && ((B = m == null ? void 0 : m.current) == null || B.style.setProperty(
      "--tw-translate-x",
      `${12 + R.width + 5}px`
    )), /* @__PURE__ */ pe("div", { className: _.wrapper, children: [
      /* @__PURE__ */ T(
        "label",
        {
          htmlFor: C,
          id: g,
          className: _.accessibleLabel,
          children: t
        }
      ),
      k && /* @__PURE__ */ T(
        "div",
        {
          ref: re,
          className: _.leftElement,
          children: k
        }
      ),
      /* @__PURE__ */ T(
        "textarea",
        {
          ref: te,
          id: C,
          name: n,
          disabled: b,
          placeholder: a ? void 0 : " ",
          className: _.textArea,
          rows: 1,
          ...d && { "aria-describedby": `${C}-helper` },
          ...r && { "aria-invalid": "true" },
          ...h && !k && !a && { style: { paddingRight: j } },
          ...k && !h && !a && { style: { paddingLeft: G } },
          ...h && k && !a && {
            style: {
              paddingRight: j,
              paddingLeft: G
            }
          },
          value: A,
          onChange: ue,
          onFocus: ie,
          onBlur: de,
          ...Z
        }
      ),
      !a && /* @__PURE__ */ T(
        "label",
        {
          ref: m,
          "aria-hidden": !0,
          htmlFor: C,
          className: `${_.visibleLabel}`,
          children: t
        }
      ),
      oe && /* @__PURE__ */ T(
        "div",
        {
          ref: S,
          id: `${C}-helper`,
          className: _.helperText,
          children: d
        }
      ),
      h && /* @__PURE__ */ T(
        "div",
        {
          ref: ne,
          className: _.rightElement,
          children: h
        }
      ),
      r && d && /* @__PURE__ */ T(Le, { politeness: "polite", clearAnnouncementDelay: 500, children: ce })
    ] });
  }
);
Pe.displayName = "TextArea";
export {
  K as TEXT_AREA_CLASSNAME,
  ge as TEXT_AREA_CONTROL_LEFT_CLASSNAME,
  Te as TEXT_AREA_CONTROL_RIGHT_CLASSNAME,
  D as TEXT_AREA_HELPER_TEXT_CLASSNAME,
  Ae as TEXT_AREA_WRAPPER_CLASSNAME,
  Pe as TextArea
};
